.TH DETEX 1L "" "Purdue University"
.SH NAME
detex \- a filter to strip  TeX commands from a .tex file.
.SH SYNOPSIS
.B detex
[ \fB\-lnw\fR ] [ \fB\-e\fI environment-list\fR ] [ \fIfilename\fR[.tex] ... ]
.SH DESCRIPTION
.I Detex
reads each file in sequence, removes all comments and replaces all
.I TeX
control sequences with a space character (To avoid words running together)
and writes the remainder on the standard output.
All text in math mode and display mode is removed.
By default,
.I detex
follows \\input commands.
If a file cannot be opened, a warning message is
printed and the command is ignored.
If the
.B \-n
option is used, no \\input or \\include commands will be processed.
This allows single file processing.
If no input file is given on the command line,
.I detex
reads from standard input.
.PP
If the magic sequence ``\\begin{document}'' appears in the text,
.I detex
assumes it is dealing with LaTeX source and
.I detex
recognizes additional constructs used in
.IR LaTeX .
These include the \\include and \\includeonly commands.
The
.B \-l
option can be used to force LaTeX mode.
.PP
Text in various environment modes of
.I LaTeX
is ignored.  The default modes are array, eqnarray, equation, figure,
picture and table.  The
.B \-e
option can be used to specify a comma separated
.I environment-list
of environments to ignore.  The list replaces the defaults so specifying an
empty list effectively causes no environments to be ignored.
.PP
.I Detex
assumes the standard character classes are being used for
.IR TeX .
.I Detex
allows white space between control sequences
and magic characters like `{' when recognizing things like
.I LaTeX
environments.
.PP
If the
.B \-w
flag is given, the output is a word list, one `word' (string of two or more
letters and apostrophes beginning with a letter)
per line, and all other characters ignored.
Without \fB\-w\fR the output follows the original,
with the deletions mentioned above.  Newline characters are
preserved where possible
so that the lines of output match the input as closely as possible.
.PP
The TEXINPUTS environment variable is used to find \\input and \\include
files.
.SH SEE ALSO
tex(1L)
.SH DIAGNOSTICS
Nesting of \\input is allowed but the number of opened files must not
exceed the system's limit on the number of simultaneously opened files.
.I Detex
ignores unrecognized option characters after printing a warning message.
.SH AUTHOR
Daniel Trinkle, Computer Science Department, Purdue University
.SH BUGS
.I Detex
is not a complete
.I TeX
interpreter, so it can be confused by some constructs.
Most errors result in too much rather than too little output.
.PP
Running \fILaTeX\fR
source without a ``\\begin{document}''
through \fIdetex\fR may produce
errors.
.PP
Suggestions for improvements are encouraged.
