.TH GFTODVI 1L  10/16/86
.SH NAME
gftodvi - make proofsheets from generic font files
.SH SYNOPSIS
.B gftodvi
gf_file_name [dvi_file_name]
.SH DESCRIPTION
.I Gftodvi
converts a generic font file (output by Metafont) to a
device independent file that can be typeset using the
software as for TeX. The characters in the gf file will
appear one per page, with labels, titles, and annotations as
specified in Appendix H (Hardcopy Proofs) of
.I The
.IR Metafontbook .
.PP
.I Gftodvi
uses three other fonts, in addition to the main gf file
input. A `gray' and a `black' font are used to typeset the
pixels that actually make up the character. (We wouldn't
want all the pixels to be simply black, since then labels,
key points, and other information would be lost.) A `slant'
font is used to typeset diagonal lines, which would
otherwise have to be simulated using horizontal and vertical rules.
.PP
The filename on the command line must be complete. Because
the resolution is part of the extension, it would not make
sense to add on a default extension as is done with TeX or
dvi-reading software. The dvi file name defaults to the same
root as the gf file, with the `dvi' extension added. For
example, the input file
.I io.2602gf
would become
.IR io.dvi .
.PP
The TEXFONTS environment variable is used to find the tfm
files. The dvi file goes in the current directory.
.SH "FILES"
/usr/local/lib/tex/fonts/{gray.tfm,...}   The default fonts
/usr/local/lib/mf/inputs/{gray.mf,...}    The Metafont sources
.SH "SEE ALSO"
tex(1), mf(1), lpr(1)
.br
Donald Knuth,
.I The Metafontbook
.br
Donald Knuth,
.I MetafontWare
.SH "AUTHORS"
Donald Knuth wrote the program. The program was published as
part of the
.I MetafontWare
technical report, available from Stanford. Paul Richards
ported it to Unix.
