.TH IPTEX 1
.SH NAME
iptex \- print DVI files on the Imagen
.SH SYNOPSIS
.B iptex
[
.B \-c
] [
.B \-d
.I maxdrift
] [
.B \-l
] [
.B \-m
.I magnification
] [
.B \-p
] [
.B \-r
.I resolution
] [
.B \-s
] [
.B \-X
.I x-offset
] [
.B \-Y
.I y-offset
]
.I filename
.SH DESCRIPTION
.I Iptex
takes a DVI file produced by TeX and converts it to a format suitable
for the Imagen series printers.
.I filename
should be the name of a
.B .dvi
file, or ``\-'' for standard input (useful for reading the output
of the
.I dviselect
program).  By default,
.I iptex
produces output for
a 300 dpi printer (the 8/300) but this may be overridden with the
.I \-r
flag:
.B "\-r 240"
produces output suitable for the Imprint-10 (a.k.a. the 10/240).
.PP
To get landscape mode (rather than portrait mode) output, use the
.B \-l
flag.  However, this has not been extensively tested.
.PP
The
.I \-m
flag applies a global magnification to the output.  If you have slides
that are to be reduced, you can fiddle with the output size using \-m.
(By the way, \-r is really \-m in disguise.)
.PP
Normally, iptex will print the page number of each page (actually
the value in \\count0) as it runs, to demonstrate its blinding speed.
If this is not desired, use the
.I \-s
option to suppress unnecessary verbiage.  (And yes, it really
.I is
supposed to count down from the last page.)
.PP
.I Iptex
is actually a shell script that invokes the conversion program and
feeds its output to Imagen's
.I ipr
command.  By default, this is done by creating a file in /tmp, so
that missing fonts can be caught before ipr runs away with the
output.  However, if desired, you can force the output to be piped
directly to ipr with the
.I \-c
flag.
.PP
The
.I maxdrift
parameter controls
.BR iptex 's
behaviour under certain obscure conditions.  Because it is so rarely
needed, and because 2 is such a wonderful default, I am not going to
tell you exactly what it really does.  (Besides, I have not yet
figured out how to describe it.)
.PP
There are three options that are normally only useful to people installing
.I iptex
which are quickly summarized here:
.B \-p
prevents page reversal (useful with the Ricoh engine);
.B \-X
and
.B \-Y
set an offset to apply to every page (useful with the LBP-10, for
example, where output starts a few tenths of an inch away from the upper
left hand corner of the page).  The offsets are in tenths of an inch
and may be negative.  Default offsets should be set in the
.I iptex
shell script; they will be overridden by explicit
.B \-X
and
.B \-Y
arguments.
.SH DIAGNOSTICS
Most of these should be self explanatory.  The message ``unable to
copy input to temp file'' should only occur when reading standard
input, and indicates that the temporary file required when reading
pipes is too large for wherever it is being stored.  The environment
variable ``TMPDIR'' defines which file system is used for this
temporary file; the default is /tmp.  Either put the intermediate DVI
file in a real disk file, or set TMPDIR, in such cases.
.SH AUTHOR
Chris Torek, University of Maryland
.br
Mike Urban (TRW) added the \-p, \-X, and \-Y options.
.SH FILES
imagen1 - conversion program
.br
ipr - Imagen spooler
.SH "SEE ALSO"
dvipr(1), dviselect(1), tex(1)
.SH BUGS
.I Still
needs to handle more ``\especial''s.
