.TH TEX 1L "15 February 1990"
.\"
.if t .ds Am A\\v'0.15v'M\\v'-0.15v'ST\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Am AmSTeX
.\"
.if t .ds Bi B\s-2IB\s+2T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Bi BibTeX
.\"
.\".if t .ds La L\\h'-0.36m'\\v'-0.15v'\\s-2A\\s+2\\h'-0.15m'\\v'0.15v'T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if t .ds La L\\h'-0.24m'\\v'-0.15v'\\s-2A\\s+2\\h'-0.15m'\\v'0.15v'T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds La LaTeX
.\"
.if t .ds Ps P\s-2OST\s+2S\s-2CRIPT\s+2
.if n .ds Ps PostScript
.\"
.if t .ds Ts T\s-2RAN\s+2S\s-2CRIPT\s+2
.if n .ds Ts TranScript
.\"
.\"
.if t .ds Sl S\s-2LI\s+2T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Sl SliTeX
.\"
.if t .ds Te T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Te TeX
.\"
.SH "NAME"
tex \- text formatting and typesetting programs
.SH "SYNOPSIS"
.B amstex
[ first line ]
.br
.B initex
[ first line ]
.br
.B latex
[ first line ]
.br
.B slitex
[ first line ]
.br
.B tex
[ first line ]
.br
.B virtex
[ first line ]
.br
.B cm-amstex
[ first line ]
.br
.B cm-initex
[ first line ]
.br
.B cm-latex
[ first line ]
.br
.B cm-slitex
[ first line ]
.br
.B cm-tex
[ first line ]
.br
.B cm-virtex
[ first line ]
.SH "ABBREVIATED DESCRIPTION"
.TP
.B amstex
The American Mathematical Society's front-end macro package for \*(Te, as
described in the book
.I "The Joy of \*(Te"
by Michael Spivak.
.TP
.B initex
Used in conjunction with
.I virtex
to create fast-loading customized version of \*(Te; creates a
.I format
(.fmt) file that permits fast loading of fonts and macro packages.
.TP
.B latex
A commonly used macro package for \*(Te, as described in the book
.IR "The \*(La Document Preparation System"
by Leslie Lamport.
.TP
.B tex
Donald Knuth's text formatting system, \*(Te.
.TP
.B slitex
A version of \*(La for making black-and-white or color slides.
.TP
.B virtex
Creates a fast-loading customized version of \*(Te; employs the
.I "format (.fmt)"
file created by
.IR initex .
.TP
.B cm-amstex
Common \*(Te (see
.IR cm-tex )
version of \*(Am.
.TP
.B cm-initex
Common \*(Te (see
.IR cm-tex )
version of
.IR initex .
.TP
.B cm-latex
Common \*(Te (see
.IR cm-tex )
version of \*(La.
.TP
.B cm-slitex
Common \*(Te (see
.IR cm-tex )
version of \*(Sl.
.TP
.B cm-tex
Common \*(Te (Pat Monardo's C version of \*(Te), compiled with large tables.
All of the
.B cm-
variants of the various versions of \*(Te require in excess of 7 MB of
main memory, and should be run only when a document requires an enlarged \*(Te,
as indicated by the message "TeX memory capacity exceeded."
.TP
.B cm-virtex
Common \*(Te (see
.IR cm-tex )
version of
.IR virtex .
.PP
Usually, these are links to a single shell script, except for
.I initex
and
.IR virtex ,
which are executable programs.
.PP
On some UNIX systems, it is possible to capture a runnable image of
.I virtex
after it has loaded the
.I .fmt
file, and then store it as a separate executable program.  On those
systems,
.IR amstex ,
.IR latex ,
.IR tex ,
and
.I slitex
may instead be binary program images.
.SH "DETAILED DESCRIPTION"
\*(Te
formats the interspersed text and commands contained in the named files
and outputs a typesetter independent file (called
.I DVI
which is short for
.IR D e V ice
.IR I ndependent ).
\*(Te capabilities and language are described in
.I The \*(Tebook
by Donald E. Knuth, published by Addison-Wesley.  There is also an older
manual,
.I \*(Te and METAFONT,
which describes the older version of \*(Te, now called \*(Te78, but this
description is now obsolete.
The present version of \*(Te (often refered to internally as \*(Te82)
incorporates literally hundreds of changes from this older version.
.LP
Any arguments given on the command line to the \*(Te
programs are passed to them as the first input line.
As described in
.I The \*(Tebook,
that line should begin with a file name
or a 
.IR \econtrolsequence .
The normal usage is to say
.RB `` tex
.IR paper ''
to start processing
.IR paper.tex .
The name
.I paper
will be the ``jobname'', and is used in forming output file names.
If \*(Te doesn't get a file name in the first line, the jobname is
.IR texput .
The default
.I .tex
extension can be overridden by specifying an extension explicitly.
.LP
If there is no
.I paper.tex
file in the current directory, \*(Te will look through a search path
of directories to try to find it.  The standard inputs directory on
the default search path has the basic format package, 
.IR plain.tex ,
described in the \*(Tebook, as well as several others.  Note that it
is hardly ever necessary to 
.IR "\einput plain" ,
since the
.I tex
program has preloaded it.  This means that all of the control
sequences discussed in the \*(Tebook are known to the program
.IR tex .
.LP
The output DVI file is written on
.I name.dvi
where
.I name
is the jobname.
A log of error messages goes into
.I name.log.
.LP
Note that there have been incompatible changes in the DVI format
between \*(Te78 and \*(Te82, so programs used to print
\*(Te78 output will not work for \*(Te82.
A number of output drivers are available.  Ask your local \*(Te
guru for information on what one you should use.
.LP
There are some environment variables that can be used to set up directory
paths to search when \*(Te opens a file for input.  For example, the
.IR csh (1)
command
.br
.in +2

setenv TEXINPUTS .:/usr/me/mylib:/usr/local/lib/tex/inputs

.in -2
or the
.IR sh (1)
command sequence
.br
.in +2

TEXINPUTS=.:/usr/me/mylib:/usr/local/lib/tex/inputs
.br
export TEXINPUTS

.in -2
.br
would cause all invocations of tex and its derivatives to look 
for 
.I \einput  
files first in the current directory, then in a hypothetical user's
``mylib'', and finally in the system directory.  Normally, the user
will place the command sequence which sets up the TEXINPUTS
environment variable in the
.I .cshrc
or
.I .profile
files.
The ENVIRONMENT section below lists the relevant environment variables,
and their defaults.
.LP
The
.I e
response to \*(Te's error prompt causes the
.I vi
editor to start up at the current line of the current file.
There is an environment variable, TEXEDIT, that can be used to change the
editor used.  It should contain a string with "%s" indicating where the
filename goes and "%d" indicating where the decimal linenumber (if any) goes.
For example, a TEXEDIT string for
.I "GNU Emacs"
can be set by:
.br
.ti +2

.nf
.if t setenv TEXEDIT "/usr/local/bin/emacs -l/usr/local/lib/tex/tex-start -estartline %d %s"
.if n setenv TEXEDIT "/usr/local/bin/emacs \e
.if n \           -l/usr/local/lib/tex/tex-start -estartline %d %s"
.fi

.br
The path name must be modified appropriately for your local version of
.IR emacs (1L).
.LP
A convenient file in the library is
.IR null.tex ,
containing nothing.
When \*(Te can not find a file it thinks you want to use as input, it keeps
asking you for another file name;  responding `null' gets you out
of the loop if you don't want to input anything.
.LP
Two other \*(Te programs,
.IR initex (1L)
and
.IR virtex (1L),
can be used to create fast-loading customized versions of \*(Te.  The
.IR initex (1L)
program is used to create a format
.I "(.fmt)"
file that permits fast loading of fonts and macro packages.
After processing the fonts and definitions desired, a 
.I \edump 
command will create the format file.  The format file is used by
.IR virtex (1L).
It needs to be given a format file name as the first thing it reads.
A format file name is preceded by an &, which needs to be escaped
with \e if given on the command line.  So, for instance, one could
create a file
.I myfmt.fmt
using
.IR initex (1L),
and then set up a
.IR csh (1)
alias with
.br
.ti +2

alias mytex "virtex \e&myfmt"

.br
to allow the use of a command like
.IR "mytex " paper .
.SH "ENVIRONMENT"
The file system path to the \*(Te directory tree varies between systems.
One common choice is for it to be found as
.IR /usr/local/lib/tex .
In the following sections, we shorten this to
.IR $TEX ,
which could be the value of an environment variable set to that path.
.PP
Environment variables that define file system search paths are expected
to follow the 
.IR csh (1)
convention of a colon-separated list of directory names, without any
embedded white space.  The size of the internal buffers provided for
storing values of these variables varies with the implementation; in
the Web2C version of \*(Te, it is 1024 characters.
.LP
.IP TEXEDIT
Command template for switching to text editor.
.IP
.RI "Default:  " "/usr/ucb/vi +%d %s" .
.IP TEXFONTS
Search path for font metric files.
.IP
.RI "Default:  " ".:$TEX/fonts/cm:$TEX/fonts/ams"
.IP
DVI drivers also use this search path to find font bitmap files; some
older ones do not support search paths, so for them, it may be
necessary to create a shadow font directory containing files which are
symbolic links to font files in the master font directories.
.IP TEXFORMATS
Search path for format 
.RI ( .fmt )
files needed by
.IR virtex .
.IP
.RI "Default:  " .:$TEX/formats .
.IP TEXINPUTS
Search path for 
.I \einput
and 
.I \eopenin
files.  The search path should start with ``.'', so that your files
cannot be overridden by library files of the same name.
.IP
.RI Default: ".:$TEX/inputs:$TEX/latex:$TEX/amstex:$TEX/bibtex"
.IP
\*(Am users should define this variable explicitly, putting the
.I amstex
directory before the
.I latex
directory, because both have
.I letter.sty
files.  Future additions to these directories could create further
name collisions, so it may be a good idea to define this variable
explicitly in your startup files, according to the version of \*(Te
that you normally use.
.IP TEXPOOL
Search path for \*(Te strings file.
.IP
.RI "Default:  " .:$TEX/inputs .
.SH "FILES AND DIRECTORIES"
.TP
.I $TEX/amstex
\*(Am macro and style files.
.TP
.I $TEX/apstex
American Physical Society macro and style files.
.TP
.I $TEX/bibtex
\*(Bi macro and style files.
.TP
.I $TEX/fonts
\*(Te fonts (bitmap files and font metric files) in subdirectories,
one per font family.  Font bitmaps are usually stored in the compact
PK format, which can be prepared automatically from the GF (generic
font) format produced by METAFONT using the
.IR gftopk (1)
utility.  Some sites may still have fonts in the obsolete disk-hungry
PXL format.
.IP
Computer Modern font bitmap files are named according to point size
and magnification (dots/inch for PK and GF formats, or for PXL
formats, about 5 times the dots/inch value).  For example, for 300dpi
laser printers, Computer Modern Roman 10pt at normal magnification can be
found in any of the files
.IR cmr10.300pk ,
.IR cmr10.300gf ,
or
.IR cmr10.1500pxl .
.IP
The \*(Te-APS \*(Ps fonts are not designed to any particular point
size, so their names do not include a point size specification;
10pt Helvetica Bold Oblique is found in the file
.IR psmhlvbo.300pk .
.IP
Other point sizes are obtained from magnifications of these.
12pt Helvetica Bold Oblique is found in the file
.IR psmhlvbo.360pk ,
since 360 is 12/10 times larger than 300.
.IP
These font bitmap files are not used by \*(Te itself; it only uses the
corresponding font metric
.RI ( .tfm )
files which contain character measurements, and kerning and ligature
information.
.TP
.I $TEX/fonts/ams
American Mathematical Society fonts.
.TP
.I $TEX/fonts/aps
Adobe \*(Ps fonts in \*(Te PK format, together with \*(Te and \*(La
style files to make them easy to use.  These are licensed fonts
available from Kinch Computer Company.  The
.I 00readme.txt
file in this directory tells how to use them.
.TP
.I $TEX/fonts/cm
\*(Te Computer Modern fonts.
.TP
.I $TEX/fonts/concrete
\*(Te Concrete fonts (a relative of Computer Modern fonts designed
especially for the book,
.IR "Concrete Mathematics" ,
co-authored by Donald E. Knuth).
.TP
.I $TEX/fonts/euler
American Mathematical Society Euler fraktur fonts.
.TP
.I $TEX/fonts/greek
Silvio Levy's Greek fonts.
.TP
.I $TEX/fonts/music
Fonts for typesetting music, designed by Andrea Steinbach and Angelika
Schofer.  The directory contains documentation in German and English.
.TP
.I $TEX/fonts/pandora
Neenie Billawala's Pandora font family, including a \*(La style file,
.IR pandora.sty ,
to make them easy to use.
.TP
.I $TEX/formats
\*(Te
.I \&.fmt
files, produced by
.I initex
for use by
.IR virtex .
.TP
.I $TEX/inputs
Plain \*(Te system files.
.TP
.I $TEX/inputs/tex.pool
Encoded text of \*(Te messages.
.TP
.I $TEX/latex
\*(La macro and style files.
.TP
.I $TEX/tugboat
TUGboat macro and style files.
.SH "SEE ALSO"
.IR "The \*(Tebook" ,
Donald E. Knuth, Addison Wesley, 1984.
.LP
.IR "The \*(La Document Preparation System" ,
Leslie Lamport, Addison Wesley, 1985.
.LP
.IR "\*(La for Engineers and Scientists" ,
David J. Buerger, McGraw-Hill, 1990.
.LP
.I The Joy of \*(Te,
Michael Spivak, American Mathematical Society, 1986.
.LP
.IR "The DVItype Processor" ,
Version 2.8, August, 1984.
.LP
.IR "Using \*(La on Berkeley UNIX" ,
Richard Furuta, Version 2.09.
.LP
.IR "Le Petit Livre de \*(Te" ,
Raymond Seroul, Intereditions, 1989.
.LP
.IR "A \*(Te DVI Driver Family" ,
Nelson H. F. Beebe, University of Utah, 1987.
.LP
.I TUGboat
(the publication of the \*(Te Users Group).
.LP
.I "Differences between \*(Te82 and SAIL \*(Te."
.LP
.IR "GNU Emacs \*(Teinfo system",
Free Software Foundation, Cambridge, MA.
.LP
.IR bibtex (1L)
(a bibliography database system for \*(La documents).
.LP
.IR dvi (1L)
(the Utah DVI driver family).
.LP
.IR makeindex (1L)
(a system for preparing indexes for \*(La documents).
.LP
.IR s2latex (1L)
(a translator from Scribe to \*(La).
.LP
.IR tr2tex (1L)
(a translator from troff to \*(La).
.SH "TRIVIA"
\*(Te, pronounced properly, rhymes with ``blecchhh''.  Note that the proper
spelling in typewriter-like output is ``TeX'', not ``TEX'' or ``tex''.
\*(La can be pronounced either as lay-\*(Te or as lah-\*(Te (with the
accent on either syllable), but not lay-tecks or L. A. tecks.
.SH "BUGS"
Maybe there should be a character other than & to specify format files,
since if you forget the \e on the command line, it doesn't do what you want!
Also, there is no way to read a \*(Te input file with no filename extension.
.SH "AUTHORS"
\*(Te was designed by Donald E. Knuth, who implemented it using his WEB
system for Pascal programs.  It was ported to UNIX at Stanford by
Howard Trickey, and at Cornell by Pavel Curtis.  The UNIX version in
Pascal is a combination of their efforts.
.PP
In 1989, Tim Morgan and Tom Rokicki developed the Web2C translator
that makes it possible to have a C version of \*(Te on UNIX systems
that lack adequate Pascal compilers.
.PP
This manual page was modified by R. P. C. Rodgers
<rodgers@maxwell.mmwb.ucsf.edu>, School of Pharmacy, University of
California at San Francisco, and updated by Nelson H. F. Beebe
<beebe@science.utah.edu>, Center for Scientific Computing and
Department of Mathematics, University of Utah, to reflect new
directory organization, new literature, and other
\*(Te-related programs.
.PP
The official distribution point for UNIX \*(Te is:
.IP
.nf
Northwest Computer Support Group
University of Washington
Mail Stop DW-10
Seattle, WA 98195
USA
Tel: (206) 543-6259 and (206) 545-2386
.fi
